# Progress API: Gradebooks

## GET /api/progress/gradebooks/{gradebook}

> Retrieves one specific gradebook

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"GradebookModel":{"type":"object","properties":{"achievementId":{"type":"string","format":"uuid","nullable":true},"eventId":{"type":"string","format":"uuid","nullable":true},"frameworkId":{"type":"string","format":"uuid","nullable":true},"gradebookId":{"type":"string","format":"uuid"},"organizationId":{"type":"string","format":"uuid"},"periodId":{"type":"string","format":"uuid","nullable":true},"isLocked":{"type":"boolean"},"gradebookTitle":{"type":"string","nullable":true},"gradebookType":{"type":"string","nullable":true},"lastChangeType":{"type":"string","nullable":true},"lastChangeUser":{"type":"string","nullable":true},"reference":{"type":"string","nullable":true},"gradebookCreated":{"type":"string","format":"date-time"},"lastChangeTime":{"type":"string","format":"date-time"},"achievementTitle":{"type":"string","nullable":true},"classInstructors":{"type":"string","nullable":true},"classScheduledStartDate":{"type":"string","nullable":true},"classScheduledEndDate":{"type":"string","nullable":true},"classTitle":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/api/progress/gradebooks/{gradebook}":{"get":{"tags":["Progress API: Gradebooks"],"summary":"Retrieves one specific gradebook","operationId":"retrieveGradebook","parameters":[{"name":"gradebook","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/GradebookModel"}},"text/json":{"schema":{"$ref":"#/components/schemas/GradebookModel"}}}}}}}}}
```

## HEAD /api/progress/gradebooks/{gradebook}

> Checks for the existence of one specific gradebook

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}}},"paths":{"/api/progress/gradebooks/{gradebook}":{"head":{"tags":["Progress API: Gradebooks"],"summary":"Checks for the existence of one specific gradebook","operationId":"assertGradebook","parameters":[{"name":"gradebook","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"boolean"}},"text/json":{"schema":{"type":"boolean"}}}}}}}}}
```

## POST /api/progress/gradebooks/collect

> Collects the list of gradebooks that match specific criteria

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"CollectGradebooks":{"type":"object","properties":{"identifier":{"type":"string","format":"uuid","nullable":true},"origin":{"$ref":"#/components/schemas/Origin"},"filter":{"$ref":"#/components/schemas/QueryFilter"},"texts":{"type":"object","additionalProperties":{"type":"string","nullable":true},"nullable":true},"achievementId":{"type":"string","format":"uuid","nullable":true},"classId":{"type":"string","format":"uuid","nullable":true},"classInstructorId":{"type":"string","format":"uuid","nullable":true},"frameworkId":{"type":"string","format":"uuid","nullable":true},"organizationId":{"type":"string","format":"uuid","nullable":true},"periodId":{"type":"string","format":"uuid","nullable":true},"isLocked":{"type":"boolean","nullable":true},"classTitle":{"type":"string","nullable":true},"gradebookTitle":{"type":"string","nullable":true},"gradebookType":{"type":"string","nullable":true},"lastChangeType":{"type":"string","nullable":true},"lastChangeUser":{"type":"string","nullable":true},"reference":{"type":"string","nullable":true},"classStartedSince":{"type":"string","format":"date-time","nullable":true},"classStartedBefore":{"type":"string","format":"date-time","nullable":true},"gradebookCreatedSince":{"type":"string","format":"date-time","nullable":true},"gradebookCreatedBefore":{"type":"string","format":"date-time","nullable":true},"lastChangeSince":{"type":"string","format":"date-time","nullable":true},"lastChangeBefore":{"type":"string","format":"date-time","nullable":true}},"additionalProperties":false},"Origin":{"type":"object","properties":{"when":{"type":"string","format":"date-time"},"organization":{"type":"string","format":"uuid"},"user":{"type":"string","format":"uuid"},"proxy":{"type":"string","format":"uuid","nullable":true},"description":{"type":"string","nullable":true},"reason":{"type":"string","nullable":true},"source":{"type":"string","nullable":true}},"additionalProperties":false},"QueryFilter":{"type":"object","properties":{"page":{"type":"integer","format":"int32"},"pageSize":{"type":"integer","format":"int32"},"sort":{"type":"string","nullable":true},"excludes":{"type":"string","nullable":true},"includes":{"type":"string","nullable":true},"format":{"type":"string","nullable":true}},"additionalProperties":false},"GradebookModel":{"type":"object","properties":{"achievementId":{"type":"string","format":"uuid","nullable":true},"eventId":{"type":"string","format":"uuid","nullable":true},"frameworkId":{"type":"string","format":"uuid","nullable":true},"gradebookId":{"type":"string","format":"uuid"},"organizationId":{"type":"string","format":"uuid"},"periodId":{"type":"string","format":"uuid","nullable":true},"isLocked":{"type":"boolean"},"gradebookTitle":{"type":"string","nullable":true},"gradebookType":{"type":"string","nullable":true},"lastChangeType":{"type":"string","nullable":true},"lastChangeUser":{"type":"string","nullable":true},"reference":{"type":"string","nullable":true},"gradebookCreated":{"type":"string","format":"date-time"},"lastChangeTime":{"type":"string","format":"date-time"},"achievementTitle":{"type":"string","nullable":true},"classInstructors":{"type":"string","nullable":true},"classScheduledStartDate":{"type":"string","nullable":true},"classScheduledEndDate":{"type":"string","nullable":true},"classTitle":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/api/progress/gradebooks/collect":{"post":{"tags":["Progress API: Gradebooks"],"summary":"Collects the list of gradebooks that match specific criteria","operationId":"collectGradebooks","requestBody":{"content":{"application/json-patch+json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}},"application/json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}},"text/json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GradebookModel"}}},"text/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GradebookModel"}}}}}}}}}}
```

## POST /api/progress/gradebooks/count

> Counts the gradebooks that match specific criteria

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"CountGradebooks":{"type":"object","properties":{"identifier":{"type":"string","format":"uuid","nullable":true},"origin":{"$ref":"#/components/schemas/Origin"},"filter":{"$ref":"#/components/schemas/QueryFilter"},"texts":{"type":"object","additionalProperties":{"type":"string","nullable":true},"nullable":true},"achievementId":{"type":"string","format":"uuid","nullable":true},"classId":{"type":"string","format":"uuid","nullable":true},"classInstructorId":{"type":"string","format":"uuid","nullable":true},"frameworkId":{"type":"string","format":"uuid","nullable":true},"organizationId":{"type":"string","format":"uuid","nullable":true},"periodId":{"type":"string","format":"uuid","nullable":true},"isLocked":{"type":"boolean","nullable":true},"classTitle":{"type":"string","nullable":true},"gradebookTitle":{"type":"string","nullable":true},"gradebookType":{"type":"string","nullable":true},"lastChangeType":{"type":"string","nullable":true},"lastChangeUser":{"type":"string","nullable":true},"reference":{"type":"string","nullable":true},"classStartedSince":{"type":"string","format":"date-time","nullable":true},"classStartedBefore":{"type":"string","format":"date-time","nullable":true},"gradebookCreatedSince":{"type":"string","format":"date-time","nullable":true},"gradebookCreatedBefore":{"type":"string","format":"date-time","nullable":true},"lastChangeSince":{"type":"string","format":"date-time","nullable":true},"lastChangeBefore":{"type":"string","format":"date-time","nullable":true}},"additionalProperties":false},"Origin":{"type":"object","properties":{"when":{"type":"string","format":"date-time"},"organization":{"type":"string","format":"uuid"},"user":{"type":"string","format":"uuid"},"proxy":{"type":"string","format":"uuid","nullable":true},"description":{"type":"string","nullable":true},"reason":{"type":"string","nullable":true},"source":{"type":"string","nullable":true}},"additionalProperties":false},"QueryFilter":{"type":"object","properties":{"page":{"type":"integer","format":"int32"},"pageSize":{"type":"integer","format":"int32"},"sort":{"type":"string","nullable":true},"excludes":{"type":"string","nullable":true},"includes":{"type":"string","nullable":true},"format":{"type":"string","nullable":true}},"additionalProperties":false},"CountResult":{"type":"object","properties":{"count":{"type":"integer","format":"int32"},"summary":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/api/progress/gradebooks/count":{"post":{"tags":["Progress API: Gradebooks"],"summary":"Counts the gradebooks that match specific criteria","operationId":"countGradebooks","requestBody":{"content":{"application/json-patch+json":{"schema":{"$ref":"#/components/schemas/CountGradebooks"}},"application/json":{"schema":{"$ref":"#/components/schemas/CountGradebooks"}},"text/json":{"schema":{"$ref":"#/components/schemas/CountGradebooks"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/CountGradebooks"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/CountResult"}},"text/json":{"schema":{"$ref":"#/components/schemas/CountResult"}}}}}}}}}
```

## POST /api/progress/gradebooks/download

> Downloads the list of gradebooks that match specific criteria

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"CollectGradebooks":{"type":"object","properties":{"identifier":{"type":"string","format":"uuid","nullable":true},"origin":{"$ref":"#/components/schemas/Origin"},"filter":{"$ref":"#/components/schemas/QueryFilter"},"texts":{"type":"object","additionalProperties":{"type":"string","nullable":true},"nullable":true},"achievementId":{"type":"string","format":"uuid","nullable":true},"classId":{"type":"string","format":"uuid","nullable":true},"classInstructorId":{"type":"string","format":"uuid","nullable":true},"frameworkId":{"type":"string","format":"uuid","nullable":true},"organizationId":{"type":"string","format":"uuid","nullable":true},"periodId":{"type":"string","format":"uuid","nullable":true},"isLocked":{"type":"boolean","nullable":true},"classTitle":{"type":"string","nullable":true},"gradebookTitle":{"type":"string","nullable":true},"gradebookType":{"type":"string","nullable":true},"lastChangeType":{"type":"string","nullable":true},"lastChangeUser":{"type":"string","nullable":true},"reference":{"type":"string","nullable":true},"classStartedSince":{"type":"string","format":"date-time","nullable":true},"classStartedBefore":{"type":"string","format":"date-time","nullable":true},"gradebookCreatedSince":{"type":"string","format":"date-time","nullable":true},"gradebookCreatedBefore":{"type":"string","format":"date-time","nullable":true},"lastChangeSince":{"type":"string","format":"date-time","nullable":true},"lastChangeBefore":{"type":"string","format":"date-time","nullable":true}},"additionalProperties":false},"Origin":{"type":"object","properties":{"when":{"type":"string","format":"date-time"},"organization":{"type":"string","format":"uuid"},"user":{"type":"string","format":"uuid"},"proxy":{"type":"string","format":"uuid","nullable":true},"description":{"type":"string","nullable":true},"reason":{"type":"string","nullable":true},"source":{"type":"string","nullable":true}},"additionalProperties":false},"QueryFilter":{"type":"object","properties":{"page":{"type":"integer","format":"int32"},"pageSize":{"type":"integer","format":"int32"},"sort":{"type":"string","nullable":true},"excludes":{"type":"string","nullable":true},"includes":{"type":"string","nullable":true},"format":{"type":"string","nullable":true}},"additionalProperties":false}}},"paths":{"/api/progress/gradebooks/download":{"post":{"tags":["Progress API: Gradebooks"],"summary":"Downloads the list of gradebooks that match specific criteria","operationId":"downloadGradebooks","requestBody":{"content":{"application/json-patch+json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}},"application/json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}},"text/json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/CollectGradebooks"}}}},"responses":{"200":{"description":"OK"}}}}}}
```

## POST /api/progress/gradebooks/search

> Searches for the list of gradebooks that match specific criteria

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"SearchGradebooks":{"type":"object","properties":{"identifier":{"type":"string","format":"uuid","nullable":true},"origin":{"$ref":"#/components/schemas/Origin"},"filter":{"$ref":"#/components/schemas/QueryFilter"},"texts":{"type":"object","additionalProperties":{"type":"string","nullable":true},"nullable":true},"organizationId":{"type":"string","format":"uuid","nullable":true},"gradebookTitle":{"type":"string","nullable":true},"gradebookCreatedSince":{"type":"string","format":"date-time","nullable":true},"gradebookCreatedBefore":{"type":"string","format":"date-time","nullable":true},"periodId":{"type":"string","format":"uuid","nullable":true},"achievementId":{"type":"string","format":"uuid","nullable":true},"frameworkId":{"type":"string","format":"uuid","nullable":true},"isLocked":{"type":"boolean","nullable":true},"classTitle":{"type":"string","nullable":true},"classStartedSince":{"type":"string","format":"date-time","nullable":true},"classStartedBefore":{"type":"string","format":"date-time","nullable":true},"classInstructorId":{"type":"string","format":"uuid","nullable":true},"classId":{"type":"string","format":"uuid","nullable":true},"gradebookType":{"type":"string","nullable":true},"lastChangeType":{"type":"string","nullable":true},"lastChangeUser":{"type":"string","nullable":true},"reference":{"type":"string","nullable":true},"lastChangeSince":{"type":"string","format":"date-time","nullable":true},"lastChangeBefore":{"type":"string","format":"date-time","nullable":true}},"additionalProperties":false},"Origin":{"type":"object","properties":{"when":{"type":"string","format":"date-time"},"organization":{"type":"string","format":"uuid"},"user":{"type":"string","format":"uuid"},"proxy":{"type":"string","format":"uuid","nullable":true},"description":{"type":"string","nullable":true},"reason":{"type":"string","nullable":true},"source":{"type":"string","nullable":true}},"additionalProperties":false},"QueryFilter":{"type":"object","properties":{"page":{"type":"integer","format":"int32"},"pageSize":{"type":"integer","format":"int32"},"sort":{"type":"string","nullable":true},"excludes":{"type":"string","nullable":true},"includes":{"type":"string","nullable":true},"format":{"type":"string","nullable":true}},"additionalProperties":false},"GradebookMatch":{"type":"object","properties":{"gradebookId":{"type":"string","format":"uuid"},"gradebookTitle":{"type":"string","nullable":true},"gradebookCreated":{"type":"string","format":"date-time"},"gradebookEnrollmentCount":{"type":"integer","format":"int32"},"classId":{"type":"string","format":"uuid","nullable":true},"classTitle":{"type":"string","nullable":true},"classStarted":{"type":"string","format":"date-time","nullable":true},"classEnded":{"type":"string","format":"date-time","nullable":true},"achievementId":{"type":"string","format":"uuid","nullable":true},"achievementTitle":{"type":"string","nullable":true},"achievementCountGranted":{"type":"integer","format":"int32"},"isLocked":{"type":"boolean"}},"additionalProperties":false}}},"paths":{"/api/progress/gradebooks/search":{"post":{"tags":["Progress API: Gradebooks"],"summary":"Searches for the list of gradebooks that match specific criteria","operationId":"searchGradebooks","requestBody":{"content":{"application/json-patch+json":{"schema":{"$ref":"#/components/schemas/SearchGradebooks"}},"application/json":{"schema":{"$ref":"#/components/schemas/SearchGradebooks"}},"text/json":{"schema":{"$ref":"#/components/schemas/SearchGradebooks"}},"application/*+json":{"schema":{"$ref":"#/components/schemas/SearchGradebooks"}}}},"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GradebookMatch"}}},"text/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/GradebookMatch"}}}}}}}}}}
```

## GET /api/progress/gradebooks/export

> DO NOT use allow this endpoint to be used in live Production environments. When time and budget permit, we will> \
> design and implement a fire-and-forget strategy managing a queue of large exports, reports, etc.

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}},"schemas":{"ExportStarted":{"type":"object","properties":{"downloadUrl":{"type":"string","nullable":true},"exportFormat":{"type":"string","nullable":true},"exportKey":{"type":"string","nullable":true},"expiry":{"type":"string","format":"date-time"}},"additionalProperties":false}}},"paths":{"/api/progress/gradebooks/export":{"get":{"tags":["Progress API: Gradebooks"],"description":"DO NOT use allow this endpoint to be used in live Production environments. When time and budget permit, we will\r\ndesign and implement a fire-and-forget strategy managing a queue of large exports, reports, etc.","parameters":[{"name":"AchievementId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"ClassId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"ClassInstructorId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"FrameworkId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"OrganizationId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"PeriodId","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"IsLocked","in":"query","schema":{"type":"boolean"}},{"name":"ClassTitle","in":"query","schema":{"type":"string"}},{"name":"GradebookTitle","in":"query","schema":{"type":"string"}},{"name":"GradebookType","in":"query","schema":{"type":"string"}},{"name":"LastChangeType","in":"query","schema":{"type":"string"}},{"name":"LastChangeUser","in":"query","schema":{"type":"string"}},{"name":"Reference","in":"query","schema":{"type":"string"}},{"name":"ClassStartedSince","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"ClassStartedBefore","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"GradebookCreatedSince","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"GradebookCreatedBefore","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"LastChangeSince","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"LastChangeBefore","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"Identifier","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"Origin.When","in":"query","schema":{"type":"string","format":"date-time"}},{"name":"Origin.Organization","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"Origin.User","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"Origin.Proxy","in":"query","schema":{"type":"string","format":"uuid"}},{"name":"Origin.Description","in":"query","schema":{"type":"string"}},{"name":"Origin.Reason","in":"query","schema":{"type":"string"}},{"name":"Origin.Source","in":"query","schema":{"type":"string"}},{"name":"Filter.Page","in":"query","schema":{"type":"integer","format":"int32"}},{"name":"Filter.PageSize","in":"query","schema":{"type":"integer","format":"int32"}},{"name":"Filter.Sort","in":"query","schema":{"type":"string"}},{"name":"Filter.Excludes","in":"query","schema":{"type":"string"}},{"name":"Filter.Includes","in":"query","schema":{"type":"string"}},{"name":"Filter.Format","in":"query","schema":{"type":"string"}},{"name":"Texts","in":"query","schema":{"type":"object","additionalProperties":{"type":"string","nullable":true}}}],"responses":{"200":{"description":"OK","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ExportStarted"}},"text/json":{"schema":{"$ref":"#/components/schemas/ExportStarted"}}}}}}}}}
```

## GET /api/progress/gradebooks/exports/{key}

>

```json
{"openapi":"3.0.1","info":{"title":"Developer API","version":"v2.0.0"},"servers":[{"url":"/v2/e01"}],"security":[{"Bearer":[]},{"Cookie":[]}],"components":{"securitySchemes":{"Bearer":{"type":"apiKey","description":"-","name":"Bearer","in":"header"},"Cookie":{"type":"apiKey","description":"-","name":"InSite.WebToken","in":"cookie"}}},"paths":{"/api/progress/gradebooks/exports/{key}":{"get":{"tags":["Progress API: Gradebooks"],"parameters":[{"name":"key","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK"}}}}}}
```
